Unit Assemble;

Interface

Uses
	App,Dialogs,Dos,Crt,Objects,Macro,Lab,Table,Views;


Type
	pAssDlg = ^tAssDlg;
	tAssDlg = Object(tDialog)
		FileName  : fNameStr;
		Constructor Init;
		Procedure   Work(aSourcename : String;MakeList : Boolean);
		Procedure   Pass2;
		Procedure   ListPass;
	End;

Const
	DiskBufferSize = 1024*8;

Const
	Bin : Array[0..15] Of Word = (1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768);
	Dez : Array[0.. 4] Of Word = (1,10,100,1000,10000);
	Hex : Array[0.. 3] Of Word = (1,16,256,4096);
	HexText : Array[0..15] Of Char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
	CommandText : Array[1..16] Of String[4] =
	( 'ADD', 'NOR', 'ROR', 'ROL',
		'SUB', 'AND','RORC','ROLC',
	 'ADDC', 'EOR', 'ASR', 'ASL',
	 'SUBC',  'OR', 'LSR','BSWP');
	ConditionText : Array[1..17] Of String[2] =
	('ME','PE','HI','LS','CC','CS','NE','EQ',
	 'VC','VS','PL','MI','GE','LT','GT','LE',
	 'TR');
	FlagText : Array[1..2] Of String[2] =
	('HF','SF');

	MaxFehler=22;
	FehlerText : Array[0..MaxFehler] Of String[80] =
	(
{ 0} 'Kein Fehler',
{ 1} 'Unbekannter Befehl',
{ 2} 'Parameter erwartet',
{ 3} 'Kein ~ oder @ erlaubt',
{ 4} 'Doppeltes Label oder Equ',
{ 5} 'Doppeltes MACRO',
{ 6} 'MACRO im MACRO nicht erlaubt',
{ 7} 'Unerwartes ENDM',
{ 8} 'ENDM erwartet',
{ 9} 'Zu viele Parameter',
{10} 'Zyklischer Macroaufruf',
{11} 'Rcksprung nicht erlaubt',
{12} '; erwartet',
{13} 'Benutzer-Abbruch',
{14} 'Zyklischer Includeaufruf',
{15} 'kein lokales Label erlaubt',
{16} 'Datei nicht gefunden',
{17} 'Name zu lang',
{18} 'Division durch Null',
{19} 'berlauf',
{20} 'Equal erwartet',
{21} 'undefiniertes Label',
{22} 'falsche Parameteranzahl');

Type
	pMemory = ^tMemory;
	tMemory = Array[0..32766] Of Word;
	tError = Record
		B,E : LongInt;
		Dateiname : PathStr;
		Nr : Byte;
	End;

Var
	Source      : tBufStream;
	Sourcename  : String;
	SourcePos,
	SourceSize  : LongInt;
	SourceEnd   : Boolean;
	Mainname    : String;
	MainPos     : LongInt;
	List        : tBufStream;
	Listname    : String;
	Dest        : tBufStream;
	Destname    : String;
	Line        : String;
	LinePos     : Byte;
	ListLine    : String;
	CodeBuffer      : Array[1..255] Of Word;
	CodeBufferSize  : Byte;
	CodeSeg,
	DataSeg     : pMemory;
	CodeSegCell,
	DataSegCell : Word;
	CodeBegin   : Word;
	Condition   : Boolean;
	Error       : Byte;
	ErrorBegin,ErrorEnd,
	LineStart : LongInt;
	LOC,LoMem   : LongInt;
	ActMacro    : Macro.pData;
	ActLabel    : Lab.pData;
	ActSegment  : tSegment;
	Macros      : tMacros;
	Labels      : tLabels;
	Tables      : tTables;
	MacroBufPtr : Word;
	MustTable   : Boolean;
	ListStatus  : ShortInt;
	ErrorText   : String;
	ErrorCount  : Byte;


Implementation

Function  Swap(w : Word): Word;
Begin
	Swap:=(w shr 8)+((w and 255) shl 8);
End;

Function Prozent(p : Byte) : String;
Var
	Hilf : String;
Begin
	Hilf:=Copy('',1,    p*55 Div 100 )
	+Copy('',1,55-(p*55 Div 100));
	Prozent:=Hilf;
End;

Function LStr(t : String;l : Byte) : String;
Begin
	LStr:=Copy(t+'                                                             ',1,l);
End;

Function RStr(t : String;l : Byte) : String;
Begin
	RStr:=t+Copy('                                                             ',1,l-Length(t));
End;

Function DecStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[5];
	n : Boolean;
Begin
	Hilf:='';n:=False;
	For i:=4 Downto 0 Do
	If ((aw Div Dez[i]) Mod 10)=0 Then
	Begin
		If n Or (i=0) Then Hilf:=Hilf+'0' Else Hilf:=Hilf+' ';
	End Else
	Begin
		Hilf:=Hilf+HexText[(aw Div Dez[i]) Mod 10];
		n:=True;
	End;
	DecStr:=Hilf;
End;

Function HexStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[16];
Begin
	Hilf:='';
	For i:=0 To 3 Do
	Hilf:=HexText[(aw Div Hex[i]) Mod 16]+Hilf;
	HexStr:=Hilf;
End;

Function BinStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[16];
Begin
	Hilf:='';
	For i:=0 To 15 Do
	Hilf:=HexText[(aw Div Bin[i]) Mod 2]+Hilf;
	BinStr:=Hilf;
End;

Procedure GetLine;
Var
	ch : Char;
	tt : Boolean;
	m : Macro.pData;
Begin
	Line:='';LinePos:=1;ListLine:='';
	If ActMacro=Nil Then
	Begin
		LineStart:=SourcePos;
		SourceEnd:=SourcePos=SourceSize;
		If Not SourceEnd Then
		Repeat
			Source.Read(ch,SizeOf(ch));
			Inc(SourcePos);
			Line:=Line+ch;
		Until (ch=#10) Or (SourcePos=SourceSize);

		If Line[Length(Line)]<>#10 Then
		Begin
			Line:=Line+#13+#10;
		End;
		ErrorEnd:=SourcePos;
	End Else
	Begin
		Line:='                              ';
		If ActMacro^.Buffer[MacroBufPtr]=#0 Then
		Begin
			MacroBufPtr:=ActMacro^.OldPos;
			m:=ActMacro^.Old;
			ActMacro^.Old:=Nil;
			ActMacro:=m;

			Line:=Line+#13+#10;
		End Else
		Repeat
			ch:=ActMacro^.Buffer[MacroBufPtr];
			Inc(MacroBufPtr);
			If (ActMacro<>Nil) And (ch='%') Then
			Begin
				ch:=ActMacro^.Buffer[MacroBufPtr];
				If ch In ['a'..'z'] Then Dec(ch,32);
				Inc(MacroBufPtr);
				Case ch Of
					'C','c'  : Line:=Line+ConditionText[ActMacro^.Condition];
					'F','f'  : Line:=Line+     FlagText[ActMacro^.Flags];
					'1'..'9' : Line:=Line+              ActMacro^.Params[Byte(ch)-48];
					'0'      : Line:=Line+'$'+HexStr(ActMacro^.Count);
					Else Line:=Line+'%'+ch;
				End;
			End Else Line:=Line+ch;
		Until (ch=#10) Or (ActMacro^.Buffer[MacroBufPtr]=#0);
	End;
	Inc(LOC);
End;

Function GetNext : String;
Var
	Hilf : String;
	tt : Boolean;
Begin
	While Line[LinePos] In [#9,' ',','] Do Inc(LinePos);

	If Line[LinePos]=';' Then
	Begin
		LinePos:=Length(Line);
	End;

	If ActMacro=Nil Then ErrorBegin:=LineStart+LinePos-1;

	Hilf:='';tt:=False;
	While (Line[LinePos] In ['A'..'z','','','','','','',
													'!'..'+','-'..':','=','~','@','"',''''])
	Or ((Line[LinePos] In [#9,' ',',']) And tt) Do
	Begin
		Case Line[LinePos] Of
			'"','''' : Begin Hilf:=Hilf+Line[LinePos]; tt:=Not(tt); End;
			'a'..'z' : If tt Then Hilf:=Hilf+Line[LinePos] Else Hilf:=Hilf+Char(Byte(Line[LinePos])-32);
			Else Hilf:=Hilf+Line[LinePos];
		End;
		Inc(LinePos);
	End;

	If ActMacro=Nil Then ErrorEnd:=LineStart+LinePos-1;

	GetNext:=Hilf;
End;

Function ExpandName(aName,aExt : String) : String;
Var
	Dir  : DirStr;
	Name : NameStr;
	Ext  : ExtStr;
Begin
	FSplit(FExpand(aName),Dir,Name,Ext);
	Ext:=aExt;
	ExpandName:=Dir+Name+aExt;
End;

Function ExpandLabel(Text : String) : String;
Var
	Hilf : String;
	nr,i : Byte;
Begin
	Hilf:='';

	For i:=1 To Length(Text) Do
	Begin
		If Text[i]='.' Then
		Begin
			If (i=1) Then
			Begin
				If ActMacro<>Nil
				Then Hilf:=ActMacro^.Name+HexStr(ActMacro^.LabCount)+'.'
				Else Hilf:=ActLabel^.Name+'.';
			End Else
			If Not (Text[i-1] In ['A'..'Z','0'..'9']) Then
			Begin
				If ActMacro<>Nil
				Then Hilf:=Hilf+ActMacro^.Name+HexStr(ActMacro^.LabCount)+'.'
				Else Hilf:=Hilf+ActLabel^.Name+'.';
			End Else Hilf:=Hilf+'.';
		End Else Hilf:=Hilf+Text[i];
	End;
	ExpandLabel:=Hilf;
End;

Function IsZahl(Text : String;Var aw : Word) : Boolean;
Var
	Hilf : Boolean;
	i : Byte;
	Nr,w1,w2 : Word;
	Op : Byte;
	L : Lab.pData;
	R : Table.pData;
Begin
	Hilf:=Text<>'';aw:=0;
	op:=0;
	For i:=2 To Length(Text) Do
	If (op=0) And (Text[i] In ['+','-','*','/','\','|','&','=','<','>']) Then Op:=i;

	If Op=0 Then
	Begin
		Case Text[1] Of
			'0'..'9' : For i:=1 To Length(Text) Do
			Begin
				If (Text[i]>='0') And (Text[i]<='9') Then aw:=aw*10+(Ord(Text[i])-48) Else Hilf:=False;
			End;
			'$' : For i:=2 To Length(Text) Do
			Begin
				If (Text[i]>='0') And (Text[i]<='9') Then aw:=aw*16+(Ord(Text[i])-48) Else
				If (Text[i]>='A') And (Text[i]<='F') Then aw:=aw*16+(Ord(Text[i])-55) Else Hilf:=False;
			End;
			'!' : If IsZahl(Copy(Text,2,Length(Text)-1),aw) Then
			Begin
				aw:=Not(aw);
			End Else Hilf:=False;
			'*' : If ActSegment=Code Then
			Begin
				MustTable:=True;
				aw:=CodeSegCell;
			End Else Error:=1;
			'A'..'Z','','','' : If ActSegment=Code Then
			Begin
				If Labels.Exists(Text,L) Then
				Begin
					MustTable:=L^.Reloable;
					aw:=L^.Wert;
				End Else
				Begin
					If Labels.NewLabel(L) Then
					Begin
						MustTable:=True;
						L^.Name:=Text;
						L^.Wert:=0;
						L^.Reloable:=True;
						L^.Defined:=False;
						aw:=0;
					End Else Error:=19;
				End;
			End Else Error:=1;
			'.' : If ActSegment=Code Then
			Begin
				MustTable:=True;
				If ActMacro<>Nil Then
				Begin
					Text:=ActMacro^.Name+HexStr(ActMacro^.LabCount)+Text;
					If Labels.Exists(Text,L) Then
					Begin
						aw:=L^.Wert;
					End Else
					Begin
						If Labels.NewLabel(L) Then
						Begin
							L^.Name:=Text;
							L^.Wert:=0;
							L^.Defined:=False;
							aw:=0;
						End Else Error:=19;
					End;
				End Else
				If ActLabel<>Nil Then
				Begin
					Text:=ActLabel^.Name+Text;
					If Labels.Exists(Text,L) Then
					Begin
						aw:=L^.Wert;
					End Else
					Begin
						If Labels.NewLabel(L) Then
						Begin
							L^.Name:=Text;
							L^.Wert:=0;
							L^.Defined:=False;
							aw:=0;
						End Else Error:=19;
					End;
				End Else
				Error:=15;
			End Else Error:=1;
			Else Hilf:=False;
		End;
	End Else
	Begin
		If IsZahl(Copy(Text,1,Op-1),w1) Then
		Begin
			If IsZahl(Copy(Text,Op+1,Length(Text)-Op),w2) Then
			Begin
				Case Text[op] Of
					'+' : Begin aw:=Word(w1+w2); End;
					'-' : Begin aw:=Word(LongInt(w1)-w2); End;
					'*' : Begin aw:=Word(w1*w2) Mod $ffff; End;
					'/' :
					Begin
						If w2=0 Then Error:=20 Else aw:=w1 Div w2;
					End;
					'\' : Begin aw:=w1 Mod w2; End;
					'|' : Begin aw:=w1 Or  w2; End;
					'&' : Begin aw:=w1 And w2; End;
					'=' : Begin aw:=Word(w1=w2); End;
					'<' : Begin aw:=Word(w1<w2); End;
					'>' : Begin aw:=Word(w1>w2); End;
				End;
			End Else Hilf:=False;
		End Else Hilf:=False;

	End;

	IsZahl:=Hilf;
End;

Function IsNo      (Text : String) : Boolean;
Begin
	IsNo:=Text='-';
End;

Function IsEqual   (Text : String) : Boolean;
Begin
	IsEqual:=Text='=';
End;

Function IsDirect  (Text : String;Var aw : Word) : Boolean;
Begin
	IsDirect:=(Text[1]='#') And (IsZahl(Copy(Text,2,Length(Text)-1),aw));
End;

Function IsIndirect(Text : String;Var aw : Word) : Boolean;
Begin
	IsIndirect:=(Text[1]='(') And (IsZahl(Copy(Text,2,Length(Text)-2),aw)) And (Text[Length(Text)]=')');
End;

Procedure HandleBLoad;
Var
	f : File Of Word;
	w,ww,a,b,i,z : Word;
	Name : String;
Begin
	Name:=GetNext;
	Assign(f,Name);
{$i-}
	Reset(f);
{$i+}
	If IOResult=0 Then
	Begin
		While Not Eof(f) Do
		Begin
			Read(f,w);w:=Swap(w);
			CodeSeg^[CodeSegCell]:=w;
			Inc(CodeSegCell);
		End;
		Close(f);
	End Else Error:=16;
End;

Procedure HandleBW;
Var
	Text : String;
	i,Nr,w : Word;
Begin
	MustTable:=False;
	Text:=GetNext;
	If IsZahl(Text,Nr) Then
	Begin
		Text:=GetNext;
		If (Text<>'') And (ActSegment=Data) Then Error:=22 Else
		Begin
			If Not IsZahl(Text,w) Then w:=0;
			If ActSegment=Code Then
			Begin
				For i:=1 To Nr Do
				Begin
					CodeSeg^[CodeSegCell]:=w;
					Inc(CodeSegCell);
				End;
			End Else
			Begin
				Inc(DataSegCell,Nr);
			End;
		End;
	End Else Error:=2;
End;

Procedure HandleBB;
Begin
End;


Procedure HandleDW;
Var
	Text : String;
	Nr : Word;
	i : Byte;
	Ende : Boolean;
	R : Table.pData;
Begin
	Ende:=False;
	Repeat
		MustTable:=False;
		Text:=GetNext;
		If (Text[1]=';') Or (Text='') Then
		Begin
			Ende:=True;
		End Else
		If (Text[1]='"') And (Text[Length(Text)]='"') Then
		Begin
			For i:=2 To Length(Text)-1 Do
			Begin
				Inc(CodeBufferSize);
				CodeBuffer[CodeBufferSize]:=Ord(Text[i]);
			End;
		End Else
		If IsZahl(Text,Nr) Then
		Begin
			If MustTable Then
			Begin
				If Tables.NewTable(R) Then
				Begin
					R^.Addr:=CodeSegCell;
					R^.Wert:=CodeSegCell+CodeBufferSize;
					Tables.SetText(R,ExpandLabel(Text));
				End Else Error:=19;
			End;
			Inc(CodeBufferSize);
			CodeBuffer[CodeBufferSize]:=Nr;
			MustTable:=False;
		End Else Error:=2;
	Until Ende;
End;

Procedure HandleDB;
Var
	Text : String;
	Nr : Word;
	i : Byte;
	Hi,Ende : Boolean;
	R : Table.pData;
Begin
	Ende:=False;Hi:=True;
	Repeat
		MustTable:=False;
		Text:=GetNext;
		If (Text[1]=';') Or (Text='') Then
		Begin
			Ende:=True;
		End Else
		If (Text[1]='"') And (Text[Length(Text)]='"') Then
		Begin
			For i:=2 To Length(Text)-1 Do
			Begin
				If Hi Then
				Begin
					Inc(CodeBufferSize);
					CodeBuffer[CodeBufferSize]:=Ord(Text[i])*256;
				End Else
				Begin
					CodeBuffer[CodeBufferSize]:=CodeBuffer[CodeBufferSize]+Ord(Text[i]);
				End;
				Hi:=Not Hi;
			End;
		End Else
		If IsZahl(Text,Nr) Then
		Begin
			If MustTable Or (Nr>255) Then Error:=2;
			If Hi Then
			Begin
				Inc(CodeBufferSize);
				CodeBuffer[CodeBufferSize]:=Ord(Nr)*256;
			End Else
			Begin
				CodeBuffer[CodeBufferSize]:=CodeBuffer[CodeBufferSize]+Ord(Nr);
			End;
			Hi:=Not Hi;
			MustTable:=False;
		End Else Error:=2;
	Until Ende;
End;

Procedure HandleEndm;
Begin
	If ActMacro<>Nil Then
	Begin
		ActMacro:=Nil;
	End Else Error:=7;
End;

Procedure HandleEqu;
Var
	Text : String;
	L : Lab.pData;
Begin
	Text:=GetNext;
	If Labels.Exists(Text,L) Then
	Begin
		If L^.Defined=False Then
		Begin
			L^.Name:=Text;
			L^.Reloable:=False;
			L^.Defined:=True;
			Text:=GetNext;
			If Not IsZahl(Text,L^.Wert) Then Error:=2;
		End Else Error:=4;
	End Else
	Begin
		If Labels.NewLabel(L) Then
		Begin
			L^.Name:=Text;
			L^.Reloable:=False;
			L^.Defined:=True;
			Text:=GetNext;
			If Not IsZahl(Text,L^.Wert) Then Error:=2;

		End Else Error:=19
	End;
End;

Procedure HandleInclude;
Var
	Text : String;
Begin
	If MainPos=0 Then
	Begin
		Sourcename:=ExpandName(GetNext,'.ASM');
		MainPos:=Source.GetPos;
		Source.Done;
		Source.Init(Sourcename,stOpenRead,DiskBufferSize);
		If Source.Status<>0 Then Error:=16;
		SourcePos:=0;
		SourceSize:=Source.GetSize;
	End Else Error:=14;
End;

Procedure HandleIf;
Var
	Text   : String;
	L : Lab.pData;
	IfLevel : Byte;
	w : Word;
Begin
	Text:=GetNext;
	If IsZahl(Text,w) Then
	Begin
		If w=0 Then
		Begin
			IfLevel:=1;
			Repeat
				GetLine;
				Text:=GetNext;
				If Text='IF' Then Inc(IfLevel);
				If Text='ENDIF' Then Dec(IfLevel);
			Until ((Text='ELSE') And (IfLevel=1)) Or
						((Text='ENDIF') And (IfLevel=0));
		End;
	End Else
	Error:=20;
	Line:='';
End;

Procedure HandleELSE;
Var
	Text   : String;
Begin
	Repeat
		GetLine;
		Text:=GetNext;
	Until (Text='ENDIF');
	Line:='';
End;

Procedure HandleENDIF;
Var
	Text   : String;
Begin
	Line:='';
End;

Procedure HandleList;
Begin
	Inc(ListStatus);
	Line:='';
End;

Procedure HandleNolist;
Begin
	Dec(ListStatus);
	Line:='';
End;

Procedure HandleMacro;
Var
	Text   : String;
	M : Macro.pData;
	MacroBuffer : Array[0..9999] Of Char;
	Nr,i : Word;
Begin
	Text:=GetNext;
	If Not Macros.Exists(Text,M) Then
	Begin
		If Macros.NewMacro(M) Then
		Begin
			M^.Name:=Text;
			M^.LabCount:=0;
			M^.Old:=Nil;

			Text:=GetNext;
			M^.sc:=17;Nr:=0;For i:=1 To 17 Do If ConditionText[i]=Text Then Nr:=i;
			If Nr>0 Then Begin M^.sc:=Nr; Text:=GetNext; End;

			M^.sf:=1;Nr:=0;For i:=1 To 2 Do If FlagText[i]=Text Then Nr:=i;
			If Nr>0 Then Begin M^.sf:=Nr; Text:=GetNext; End;



			MacroBufPtr:=0;

			Repeat
				GetLine;
				If SourceEnd Then Error:=8;
				Text:=GetNext;
				If Text<>'ENDM' Then
				Begin
					Move(Line[1],MacroBuffer[MacroBufPtr],Length(Line));
					Inc(MacroBufPtr,Length(Line));
				End;
			Until (Text='ENDM') Or (Error>0);

			If Error=0 Then
			Begin
				MacroBuffer[MacroBufPtr]:=#0;
				M^.BufferSize:=MacroBufPtr+1;
				GetMem(M^.Buffer,M^.BufferSize);
				Move(MacroBuffer,M^.Buffer^,M^.BufferSize);
				Line:='';
			End;

		End Else Error:=19;
	End Else Error:=5
End;

Procedure HandleOrigin;
Var
	Text : String;
	Nr : Word;
Begin
	Text:=GetNext;
	If IsZahl(Text,Nr) Then
	Begin
		If Nr>CodeSegCell Then
		Begin
			CodeSegCell:=Nr;
			If CodeBegin=0 Then CodeBegin:=Nr;
		End Else Error:=11;
	End Else Error:=2;
End;


Function IsNewLabel(Text : String) : Boolean;
Var
	Hilf : Boolean;
	L : Lab.pData;
	Local : Boolean;
Begin
	Hilf:=Text[Length(Text)]=':';
	If Hilf Then
	Begin
		Begin
			Local:=Text[1]='.';
			If Local Then
			Begin
				If ActMacro<>Nil Then
				Begin
					Text:=ActMacro^.Name+HexStr(ActMacro^.LabCount)+Text;
				End Else
				If ActLabel<>Nil Then
				Begin
					Text:=ActLabel^.Name+Text;
				End	Else Error:=15;
			End;
			If Labels.Exists(Copy(Text,1,Length(Text)-1),L) Then
			Begin
				If L^.Defined=False Then
				Begin
					L^.Segment:=ActSegment;
					L^.Defined:=True;
					If ActSegment=Code
					Then L^.Wert:=CodeSegCell
					Else L^.Wert:=DataSegCell;
					L^.Reloable:=True;
				End Else Error:=4;
			End Else
			Begin
				If Labels.NewLabel(L) Then
				Begin
					L^.Name:=Copy(Text,1,Length(Text)-1);
					L^.Segment:=ActSegment;
					L^.Defined:=True;
					If ActSegment=Code
					Then L^.Wert:=CodeSegCell
					Else L^.Wert:=DataSegCell;
					L^.Reloable:=True;
				End;
			End;
			If (Not Local) And (ActSegment=Code) Then ActLabel:=L;
		End;
	End;
	IsNewLabel:=Hilf;
End;


Function IsExtra(Text : String) : Boolean;
Var
	Hilf : Boolean;
	Nr : Word;
Begin
	Hilf:=True;
	If Text='BLOAD' Then
	Begin
		HandleBLoad;
	End Else
	If Text='DATA' Then
	Begin
		ActSegment:=Data;
		Line:='';
	End Else
	If Text='DB' Then
	Begin
		HandleDB;
	End Else
	If Text='BW' Then
	Begin
		HandleBW;
	End Else
	If Text='DW' Then
	Begin
		HandleDW;
	End Else
	If Text='ENDM' Then
	Begin
		HandleEndm;
	End Else
	If Text='EQU' Then
	Begin
		HandleEqu;
	End Else
	If Text='IF' Then
	Begin
		HandleIf;
	End Else
	If Text='ELSE' Then
	Begin
		HandleElse;
	End Else
	If Text='ENDIF' Then
	Begin
		HandleEndIf;
	End Else
	If Text='INCLUDE' Then
	Begin
		HandleInclude;
	End Else
	If Text='LIST' Then
	Begin
		HandleList;
	End Else
	If Text='NOLIST' Then
	Begin
		HandleNolist;
	End Else
	If Text='MACRO' Then
	Begin
		HandleMacro;
	End Else
	If Text='ORIGIN' Then
	Begin
		HandleOrigin;
	End Else
	If Text='ERROR' Then
	Begin
		Error:=22;
	End Else
	Hilf:=False;
	IsExtra:=Hilf;
End;

Function IsMacro(Text : String) : Boolean;
Var
	Hilf : Boolean;
	M : Macro.pData;
	Nr,i : Word;
	OldMacro : Macro.pData;
Begin
	Hilf:=Macros.Exists(Text,M);
	If Hilf Then
	Begin
		If M^.Old=Nil Then
		Begin
			M^.Old:=ActMacro;
			M^.OldPos:=MacroBufPtr;

			MacroBufPtr:=0;
			With m^  Do
			Begin
				Inc(Labcount);
				Text:=GetNext;
				Condition:=sc;Nr:=0;For i:=1 To 17 Do If ConditionText[i]=Text Then Nr:=i;
				If Nr>0 Then Begin Condition:=Nr; Text:=GetNext; End;

				Flags:=sf;Nr:=0;For i:=1 To 2 Do If FlagText[i]=Text Then Nr:=i;
				If Nr>0 Then Begin Flags:=Nr; Text:=GetNext; End;

				Count:=0;
				For i:=1 To 9 Do
				Begin
					If Text<>'' Then Inc(Count);
					Params[i]:=ExpandLabel(Text);
					Text:=GetNext;
				End;
			End;
			ActMacro:=M;
		End Else Error:=6;
	End;
	IsMacro:=Hilf;
End;

Function IsCommand(Text : String) : Boolean;
Var
	i,Nr : Byte;
Begin
	Nr:=0;
	For i:=1 To 16 Do
	If (Nr=0) And (CommandText[i]=Text) Then Nr:=i;
	If Nr>0 Then
	Begin
		Inc(CodeBufferSize);
		CodeBuffer[1]:=Nr-1;
	End;
	IsCommand:=Nr>0;
End;

Function IsCondition(Text : String) : Boolean;
Var
	i,Nr : Byte;
Begin
	Nr:=0;
	For i:=1 To 17 Do
	If (Nr=0) And (ConditionText[i]=Text) Then Nr:=i;
	Condition:=(Nr>0) And (Nr<17);
	If Condition Then
	Begin
		CodeBuffer[1]:=CodeBuffer[1] Or (Nr-1)*4096;
	End Else
	Begin
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[11];
	End;
	IsCondition:=Nr>0;
End;

Function IsFlag     (Text : String) : Boolean;
Var
	i,Nr : Byte;
Begin
	Nr:=0;
	For i:=1 To 2 Do
	If (Nr=0) And (FlagText[i]=Text) Then Nr:=i;
	If Nr=2 Then
	Begin
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[10];
	End;
	IsFlag:=Nr>0;
End;

Function IsXWert    (Text : String) : Boolean;
Var
	R : Table.pData;
Begin
	If (Text[1]='~') Then
	Begin
		If (Not Condition) Then
		Begin
			CodeBuffer[1]:=CodeBuffer[1] Or Bin[15];
			Text:=Copy(Text,2,Length(Text)-1);
		End Else Error:=3;
	End;
	If (Error=0) And (Text[1]='@') Then
	Begin
		If (Not Condition) Then
		Begin
			CodeBuffer[1]:=CodeBuffer[1] Or Bin[14];
			Text:=Copy(Text,2,Length(Text)-1);
		End Else Error:=3;
	End;

	MustTable:=False;
	If Error=0 Then
	If IsNo(Text) Or (Text='#1') Then
	Begin
	End Else
	If IsDirect(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[4];
	End Else
	If IsZahl(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[5];
	End Else
	If IsIndirect(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[4] Or Bin[5];
	End Else
	Error:=2;
	IsXWert:=Error=0;
End;

Function IsYWert    (Text : String) : Boolean;
Var
	R : Table.pData;
	L : Lab.pData;
Begin
	MustTable:=False;
	If IsNo(Text) Or (Text='#0') Then
	Begin
	End Else
	If IsDirect(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[6];
	End Else
	If IsZahl(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[7];
	End Else
	If IsIndirect(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[6] Or Bin[7];
	End Else
	Error:=2;
	IsyWert:=Error=0;
End;

Function IsZWert    (Text : String) : Boolean;
Var
	R : Table.pData;
Begin
	If (Text[1]='~') Then
	Begin
		If (Not Condition) Then
		Begin
			CodeBuffer[1]:=CodeBuffer[1] Or Bin[13];
			Text:=Copy(Text,2,Length(Text)-1);
		End Else Error:=3;
	End;
	If (Error=0) And (Text[1]='@') Then
	Begin
		If (Not Condition) Then
		Begin
			CodeBuffer[1]:=CodeBuffer[1] Or Bin[12];
			Text:=Copy(Text,2,Length(Text)-1);
		End Else Error:=3;
	End;

	MustTable:=False;
	If Error=0 Then
	If IsNo(Text) Then
	Begin
	End Else
	If IsEqual(Text) Then
	Begin
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[8];
	End Else
	If IsZahl(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[9];
	End Else
	If IsIndirect(Text,CodeBuffer[CodeBufferSize+1]) Then
	Begin
		If MustTable Then
		Begin
			If Tables.NewTable(R) Then
			Begin
				R^.Addr:=CodeSegCell;
				R^.Wert:=CodeSegCell+CodeBufferSize;
				Tables.SetText(R,ExpandLabel(Text));
			End Else Error:=19;
		End;
		Inc(CodeBufferSize);
		CodeBuffer[1]:=CodeBuffer[1] Or Bin[8] Or Bin[9];
	End Else
	Error:=2;
	IszWert:=Error=0;
End;

Procedure tAssDlg.Pass2;
Var
	L : Lab.pData;
	R : Table.pData;
	T : String;
	i,j : Byte;
	Local : Boolean;
	Nr : Word;

	Function IsZahl(Text : String;Var aw : Word) : Boolean;
	Var
		Hilf : Boolean;
		i : Byte;
		Nr,w1,w2 : Word;
		Op : Byte;
		L : Lab.pData;
	Begin
		Hilf:=Text<>'';aw:=0;
		op:=0;
		For i:=2 To Length(Text) Do
		If (op=0) And (Text[i] In ['+','-','*','/','\','|','&']) Then Op:=i;

		If Op=0 Then
		Begin
			Case Text[1] Of
				'0'..'9' : For i:=1 To Length(Text) Do
				Begin
					If (Text[i]>='0') And (Text[i]<='9') Then aw:=aw*10+(Ord(Text[i])-48) Else Hilf:=False;
				End;
				'$' : For i:=2 To Length(Text) Do
				Begin
					If (Text[i]>='0') And (Text[i]<='9') Then aw:=aw*16+(Ord(Text[i])-48) Else
					If (Text[i]>='A') And (Text[i]<='F') Then aw:=aw*16+(Ord(Text[i])-55) Else Hilf:=False;
				End;
				'!' : If IsZahl(Copy(Text,2,Length(Text)-1),aw) Then
				Begin
					aw:=Not(aw);
				End Else Hilf:=False;
				'*' :
				Begin
					aw:=R^.Addr;
					R^.ReloAble:=True;
				End;
				'A'..'Z','','','' :
				Begin
					If Labels.Exists(Text,L) Then
					Begin
						aw:=L^.Wert;
						ActLabel:=L;
						R^.ReloAble:=L^.ReloAble;
					End;
				End;
				Else Hilf:=False;
			End;
		End Else
		Begin
			If IsZahl(Copy(Text,1,Op-1),w1) Then
			Begin
				If IsZahl(Copy(Text,Op+1,Length(Text)-Op),w2) Then
				Begin
					Case Text[op] Of
						'+' : Begin aw:=Word(w1+w2); End;
						'-' : Begin aw:=Word(LongInt(w1)-w2); End;
						'*' : Begin aw:=Word(w1*w2) Mod $ffff; End;
						'/' :
						Begin
							If w2=0 Then Error:=20 Else aw:=w1 Div w2;
						End;
						'\' : Begin aw:=w1 Mod w2; End;
						'|' : Begin aw:=w1 Or  w2; End;
						'&' : Begin aw:=w1 And w2; End;
					End;
				End Else Hilf:=False;
			End Else Hilf:=False;
		End;
		IsZahl:=Hilf;
	End;

Var
	CodeCount : Word;

Begin

	L:=Labels.Datas;
	While (L<>Nil) And (Error=0) Do
	With L^ Do
	Begin
		If Defined=False Then Begin ErrorText:=l^.Name; Error:=21; End;
		If Segment=Data Then Inc(Wert,CodeSegCell);
		L:=L^.Next;
	End;



	CodeCount:=0;

	R:=Tables.Datas;
	While R<>Nil Do
	With R^ Do
	Begin
		T:='';
		For i:=0 To BufferSize-2 Do
		Case Buffer[i] Of
			'~','@','(',')','#' : ;
			'.' :
			Begin
				T:=T+Buffer[i];
			End;
			Else T:=T+Buffer[i];
		End;

		If IsZahl(T,Nr) Then
		Begin
			CodeSeg^[Wert-Codebegin]:=Nr;
		End Else
		Begin
			Halt(255);
		End;
		R:=R^.Next;
		Inc(CodeCount);
		If (CodeCount Mod 20)=0 Then WriteStr(1,3,Prozent(LongInt(CodeCount)*100 Div Tables.Count),1);
	End;
	WriteStr(1,3,Prozent(100),1);
End;


Procedure tAssDlg.ListPass;
Var
	CodeCount : Word;
	T,tt : String;
	R : Table.pData;
	L : Lab.pData;
	i,j : Integer;
	Local : Boolean;
Begin
	CodeCount:=CodeBegin;

	List.Init(ListName,stOpen,DiskBufferSize);
	While (List.Status=0) And (CodeCount<=Tables.Datas^.Wert) Do
	Begin
		List.Read(T[1],5);T[0]:=#5;

		While (HexStr(Codecount)+':'<>T) And (t<>'    :') And (List.Status=0) Do
		Begin
			Inc(CodeCount);
		End;

		If (List.Status=0) Then
		For i:=1 To 4 Do
		Begin
			List.Read(T[1],5);T[0]:=#5;
			If (T<>'     ') Then
			Begin
				If Tables.Exists(CodeCount,R) Then
				Begin
					T:=HexStr(CodeSeg^[CodeCount-CodeBegin]);
					If (r^.Reloable) And (CodeBegin=0) Then T:=T+'_' Else T:=T+' ';
					List.Seek(List.GetPos-5);
					List.Write(T[1],5);
				End;
				Inc(CodeCount);

				If CodeCount Mod 200=0 Then
				WriteStr(1,3,Prozent(LongInt(CodeCount-CodeBegin-1)*100 Div (Tables.Datas^.Wert-CodeBegin)),1);
			End;
		End;
		Repeat
			List.Read(T[1],1);
		Until (T[1]=#10) Or (List.Status<>0);
	End;

	Labels.Sort;

	WriteStr(1,3,Prozent(100),1);

	List.Seek(List.GetSize);

	ListLine:=#13+#10+'------------------------------------------------------------------------------'+#13+#10+#13+#10;
	List.Write(ListLine[1],Length(ListLine));

	i:=0;
	L:=Labels.Datas;
	While L<>Nil Do
	Begin
		If L^.Reloable Then
		Begin
			Local:=False;
			For j:=1 To Length(L^.Name) Do If L^.Name[j]='.' Then Local:=True;
			If Not Local Then
			Begin
				Inc(i);
				ListLine:=LStr(L^.Name,32)+'='+HexStr(L^.Wert)+'  ';
				If i Mod 2=0 Then ListLine:=ListLine+#13+#10;
				List.Write(ListLine[1],Byte(ListLine[0]));
			End;
		End;
		L:=L^.Next;
	End;

	List.Done;
End;

Constructor tAssDlg.Init;
Var
	r : tRect;
Begin
	r.Assign(0,0,60,8);
	Inherited Init(r,'Assembliere');
	r.Assign( 2, 1,15, 2);Insert(New(pStaticText,Init(r,'HauptDatei:')));
	r.Assign( 2, 2,15, 3);Insert(New(pStaticText,Init(r,'akt. Datei:')));
	r.Assign( 2, 5,49, 6);Insert(New(pStaticText,Init(r,'Memory    :       Kb')));
End;

Procedure tAssDlg.Work;
Var
	h1,m1,s1,u1,h2,m2,s2,u2 : Word;
	Zeit1,Zeit2 : LongInt;
	Text,xText,yText,zText : String;
	xb,xe,yb,ye,zb,ze : LongInt;
	Frei : LongInt;
	i,j : Word;
	R : Table.pData;
	L : Lab.pData;
	Nr,w : Word;
	m : LongInt;
Begin
	m:=MemAvail;
	New(CodeSeg);
	New(DataSeg);

	Macros.Init;
	Labels.Init;
	Tables.Init;

	ListStatus:=0;
	Mainname:=ExpandName(aSourcename,'.ASM');
	Sourcename:=Mainname;
	Listname:=ExpandName(aSourcename,'.LST');
	Destname:=ExpandName(aSourcename,'.OBJ');

	WriteStr(13,1,LStr(MainName,45),1);
	WriteStr(13,2,LStr(SourceName,45),1);
	GetTime(h1,m1,s1,h1);Zeit1:=s1+60*(m1+60*LongInt(h1));

	Source.Init(SourceName,stOpenRead,DiskBufferSize);
	SourceSize:=Source.GetSize;
	SourcePos:=0;MainPos:=0;

	List.Init(ListName,stCreate,DiskBufferSize);

	ErrorCount:=0;
	LOC:=0;Error:=0;ErrorText:='';
	CodeSegCell:=0;DataSegCell:=0;
	CodeBegin:=0;
	ActMacro:=Nil;ActLabel:=Nil;
	ActSegment:=Code;

	Repeat
		CodeBufferSize:=0;
		GetLine;

		Text:=GetNext;

		While IsNewLabel(Text) Do
		Begin
			Text:=GetNext;
		End;

		Case ActSegment Of
			Code :
			Begin

				If Text='' Then
				Begin
				End Else
				If IsExtra(Text) Then
				Begin
				End Else
				If IsMacro(Text) Then
				Begin
				End Else
				If IsCommand(Text) Then
				Begin
					Text:=GetNext;
					If IsCondition(Text) Then
					Begin
						Text:=GetNext;
					End;
					If IsFlag(Text) Then
					Begin
						Text:=GetNext;
					End;

					If IsXWert(Text) Then
					Begin
						Case (CodeBuffer[1] And 15) Of
							0,4,8,12,1,5,9,13 :
							Begin
								Text:=GetNext;
								If IsYWert(Text) Then
								Begin
									Text:=GetNext; If Text='' Then Text:='=';
									If IsZWert(Text) Then
									Begin
									End Else If Error=0 Then Error:=2;
								End Else If Error=0 Then Error:=2;
							End;
							2,6,10,14,3,7,11 :
							Begin
								xText:=Text;
								yText:=GetNext; yb:=ErrorBegin; ye:=ErrorEnd;
								zText:=GetNext; zb:=ErrorBegin; ze:=ErrorEnd;
								If zText='' Then
								Begin
									If yText='' Then
									Begin
										zText:=xText;
										yText:='-';
									End Else
									Begin
										zText:=yText;
										yText:='-';
									End;
								End;
								ErrorBegin:=yb;ErrorEnd:=ye;
								If IsYWert(yText) Then
								Begin
									ErrorBegin:=zb;ErrorEnd:=ze;
									If IsZWert(zText) Then
									Begin
									End Else If Error=0 Then Error:=2;
								End Else If Error=0 Then Error:=2;
							End;
							15 :
							Begin
								xText:=Text;
								yText:=GetNext; yb:=ErrorBegin; ye:=ErrorEnd;
								zText:=GetNext; zb:=ErrorBegin; ze:=ErrorEnd;
								If zText='' Then
								Begin
									If yText='' Then
									Begin
										zText:='=';
										yText:=xText;
									End Else
									Begin
										zText:='=';
									End;
								End;
								ErrorBegin:=yb;ErrorEnd:=ye;
								If IsYWert(yText) Then
								Begin
									ErrorBegin:=zb;ErrorEnd:=ze;
									If IsZWert(zText) Then
									Begin
									End Else If Error=0 Then Error:=2;
								End Else If Error=0 Then Error:=2;
							End;
						End;
					End Else If Error=0 Then Error:=2;
				End Else
				Begin
					Error:=1;
				End;

				If (Line<>'') And (Line<>#13+#10) Then
				Begin
					For i:=0 To Integer(CodeBufferSize-1) Div 4 Do
					Begin
						If i=0
						Then ListLine:=HexStr(CodeSegCell)+':'
						Else ListLine:='    :';

						For j:=0 To 3 Do
						If j+i*4<CodeBufferSize
						Then
						Begin
							If Tables.Exists(CodeSegCell+j+i*4,r) And (CodeBuffer[1+j+i*4]=0)
							Then ListLine:=ListLine+'XXXX '
							Else ListLine:=ListLine+HexStr(CodeBuffer[1+j+i*4])+' '
						End	Else ListLine:=ListLine+'     ';

						ListLine:=ListLine+'|';
						If i=0 Then ListLine:=ListLine+Line Else ListLine:=ListLine+#13+#10;

						If ListStatus>=0 Then List.Write(ListLine[1],Byte(ListLine[0]));
					End;
				End;

				If CodeBuffersize>0 Then
				Begin
					For i:=1 To CodeBufferSize Do
					CodeSeg^[CodeSegCell-CodeBegin+i-1]:=CodeBuffer[i];
					CodeSegCell:=CodeSegCell+CodeBufferSize;
				End;
			End;
			Data :
			Begin
				If Text='' Then
				Begin
				End Else
				If Text='CODE' Then
				Begin
					ActSegment:=Code;
				End Else
				If Text='BW' Then
				Begin
					HandlebW;
				End Else
				Error:=1;
			End;
		End;

		If (SourceEnd) And (MainPos<>0) Then
		Begin
			SourceEnd:=False;
			Source.Done;
			Source.Init(Mainname,stOpenRead,DiskBufferSize);
			Source.Seek(MainPos);
			SourceName:=MainName;
			SourcePos:=MainPos;
			SourceSize:=Source.GetSize;
			MainPos:=0;
			ActSegment:=Code;
			WriteStr(13,2,LStr(SourceName,45),1);
			WriteStr(1,4,LStr('',55),1);
		End;


		If ((LOC Mod 50)=0) Then
		Begin
			WriteStr(13,2,LStr(SourceName,45),1);
			If MainPos=0
			Then Begin WriteStr(1,3,Prozent((SourcePos)*100 Div SourceSize),1); End
			Else Begin WriteStr(1,4,Prozent((SourcePos)*100 Div SourceSize),1); End;
			WriteStr(13,5,DecStr(MemAvail shr 10),1);
		End;
		GotoXY(1,8);
		If KeyPressed Then
		Begin
			If ReadKey=#27 Then	Error:=13;
		End;
	Until (SourceEnd) Or (Error>0);

	WriteStr(1,3,Prozent(100),1);

	Source.Done;

	List.Done;

	If Error=0 Then
	Begin
		Pass2;
		Dest.Init(DestName,stCreate,DiskBufferSize);
		If CodeBegin=0 Then
		Begin
			w:=swap(CodeSegCell+DataSegCell);
			Dest.Write(w,SizeOf(w));
			w:=swap(CodeSegCell);
			Dest.Write(w,SizeOf(w));
		End;

		For i:=0 To CodeSegCell-CodeBegin-1 Do
		Begin
			w:=swap(CodeSeg^[i]);
			Dest.Write(w,SizeOf(w));
		End;

		If CodeBegin=0 Then
		Begin
			R:=Tables.Datas;
			While R<>Nil Do
			Begin
				If R^.Reloable Then
				Begin
					w:=swap(R^.Wert);
					Dest.Write(w,SizeOf(w));
				End;
				R:=R^.Next;
			End;
		End;

		Dest.Done;

		If MakeList Then ListPass;
	End;

	Tables.Done;
	Labels.Done;
	Macros.Done;

	Dispose(DataSeg);
	Dispose(CodeSeg);

	m:=MemAvail;
End;

Begin
End.