Unit Lab;

Interface

Uses
	Crt;
Const
	LabelBufferSize = 32;

Type
	tSegment = (Code,Data);
	pData = ^tData;
	tData = Record
		Name : String[32];
		Wert : Word;
		ReloAble : Boolean;
		Defined : Boolean;
		Segment : tSegment;
		Next : pData;
	End;

	pLabels = ^tLabels;
	tLabels = Object
		Datas : pData;
		Count : Word;
		Constructor Init;
		Destructor  Done;
		Function    NewLabel(Var p : pData) : Boolean;
		Function    Exists(aName : String;Var p : pData) : Boolean;
		Procedure   Sort;
	End;

Implementation

Constructor tLabels.Init;
Begin
	Datas:=Nil;
	Count:=0;
End;

Destructor  tLabels.Done;
Var
	p,q : pData;
Begin
	p:=Datas;
	While p<>Nil Do
	Begin
		q:=p^.Next;
		Dispose(p);
		p:=q;
	End;
End;


Function    tLabels.NewLabel;
Begin
	NewLabel:=MemAvail>SizeOf(pData)+8192;
	If MemAvail>SizeOf(pData)+8192 Then
	Begin
		New(p);
		p^.Next:=Datas;
		Datas:=p;
		Inc(Count);
	End;
End;

Function    tLabels.Exists;
Var
	q : pData;
Begin
	p:=Nil;
	q:=Datas;
	While q<>Nil Do
	Begin
		If q^.Name=aName Then p:=q;
		q:=q^.Next;
	End;

	Exists:=p<>Nil;
End;


Procedure   tLabels.Sort;
Var
	p,q : pData;
	i : Word;
Begin
	For i:=1 To Count-1 Do
	Begin
		If Datas^.Name>Datas^.Next^.Name Then
		Begin
			p:=Datas;
			Datas:=Datas^.Next;
			p^.Next:=Datas^.Next;
			Datas^.Next:=p;
		End;

		q:=Datas;
		While (q^.Next<>Nil) And (q^.Next^.Next<>Nil) Do
		Begin
			If q^.Next^.Name>q^.Next^.Next^.Name Then
			Begin
				p:=q^.Next;
				q^.Next:=q^.Next^.Next;
				p^.Next:=p^.Next^.Next;
				q^.Next^.Next:=p;
			End;
			q:=q^.Next;
		End;
	End;
End;

End.