Unit Macro;

Interface

Const
	MacroBufferSize = 1024;

Type
	pData = ^tData;
	tData = Record
		Name : String[32];
		Condition,Flags,
		sc,sf  : Word;
		Params : Array[1..9] Of String[32];
		Count  : Word;
		LabCount : Word;
		Buffer : PChar;
		BufferSize : Word;
		Oldpos : Word;
		Next,Old : pData;
	End;

	pMacros = ^tMacros;
	tMacros = Object
		Datas : pData;
		Count : Word;
		Constructor Init;
		Destructor  Done;
		Function    NewMacro(Var p : pData) : Boolean;
		Function    Exists(aName : String;Var p : pData) : Boolean;
	End;

Implementation

Constructor tMacros.Init;
Begin
	Datas:=Nil;
	Count:=0;
End;

Destructor  tMacros.Done;
Var
	p,q : pData;
Begin
	p:=Datas;
	While p<>Nil Do
	Begin
		q:=p^.Next;
		If p^.Buffer<>Nil Then FreeMem(p^.Buffer,p^.Buffersize);
		Dispose(p);
		p:=q;
	End;
End;


Function    tMacros.NewMacro;
Begin
	NewMacro:=MemAvail>SizeOf(pData)+8192;
	If MemAvail>SizeOf(pData)+8192 Then
	Begin
		New(p);
		p^.Buffer:=Nil;
		p^.Next:=Datas;
		Datas:=p;
		Inc(Count);
	End;
End;

Function    tMacros.Exists;
Var
	q : pData;
Begin
	p:=Nil;
	q:=Datas;
	While q<>Nil Do
	Begin
		If q^.Name=aName Then p:=q;
		q:=q^.Next;
	End;

	Exists:=p<>Nil;
End;


End.