Unit Table;

Interface

Uses
	Crt;

Type
	pData = ^tData;
	tData = Record
		Addr,
		Wert       : Word;
		Buffer     : pChar{Pointer};
		BufferSize : Word;
		Reloable   : Boolean;
		Next        : pData;
	End;

	pTables = ^tTables;
	tTables = Object
		Datas : pData;
		Count : Word;
		Constructor Init;
		Destructor  Done;
		Function    NewTable(Var p : pData) : Boolean;
		Procedure   SetText(p : pData;t : String);
		Function    Exists(aWert : Word;Var p : pData) : Boolean;
	End;

Implementation

Constructor tTables.Init;
Begin
	Datas:=Nil;
	Count:=0;
End;

Destructor  tTables.Done;
Var
	p,q : pData;
Begin
	p:=Datas;
	While p<>Nil Do
	Begin
		q:=p^.Next;
		If p^.Buffer<>Nil Then Begin FreeMem(p^.Buffer,p^.BufferSize); p^.Buffer:=Nil; End;
		Dispose(p);
		p:=q;
	End;
End;


Function    tTables.NewTable;
Begin
	NewTable:=MemAvail>SizeOf(pData)+8192;
	If MemAvail>SizeOf(pData)+8192 Then
	Begin
		New(p);
		p^.Buffer:=Nil;
		p^.Next:=Datas;
		Datas:=p;
		Inc(Count);
	End;
End;

Procedure   tTables.SetText;
Begin
	With p^ Do
	Begin
		BufferSize:=Length(T)+1;
		GetMem(Buffer,BufferSize);
		Move(T[1],Buffer^,BufferSize-1);
		pChar(Buffer)[BufferSize-1]:=#0;
	End;
End;

Function    tTables.Exists;
Var
	q : pData;
Begin
	p:=Nil;
	q:=Datas;
	While q<>Nil Do
	Begin
		If q^.Wert=aWert Then p:=q;
		q:=q^.Next;
	End;

	Exists:=p<>Nil;
End;


End.