Program XAssIde;

{$M 16384,8192,655360}

Uses
	Crt,Dos,Objects,Drivers,Memory,Views,Menus,Dialogs,StdDlgG,MsgBox,App,EditorsG,Gadgets,
	Assemble;

Const
	HeapSize = 320 * (1024 div 16); { 320 Kb Heap }

Const
	cmCalculator = 101;
	cmShowClip   = 102;
	cmAss        = 201;
	cmAssList    = 202;


Type
	pEditorApp = ^tEditorApp;
	tEditorApp = Object(TApplication)
		HeapView    : pHeapView;
		ClockView   : pClockView;
		MessageView : pMessageView;
		Constructor Init;
		Procedure   Idle; Virtual;
		Procedure   HandleEvent(var Event: TEvent); virtual;
		Procedure   InitMenuBar; virtual;
		Procedure   InitStatusLine; virtual;
		Procedure   OutOfMemory; virtual;
	End;

var
	EditorApp: tEditorApp;
	ClipWindow: pEditWindow;
	ErrorNr     : Byte;

Procedure Expand(Var p : FNameStr);
Var
	d : DirStr;
	n : NameStr;
	e : ExtStr;
Begin
	FSplit(p,d,n,e);
	p:=d+n+'.ASM';
End;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
	P: PWindow;
	R: TRect;
begin
	DeskTop^.GetExtent(R);
	P := New(PEditWindow, Init(R, FileName, wnNoNumber));
	if not Visible then P^.Hide;
	OpenEditor := PEditWindow(Application^.InsertWindow(P));
end;

Procedure ShowError;
Var
	p : pEditWindow;
	q : pView;
Begin
	q:=Desktop^.Current;p:=Nil;
	Repeat
		If (Error>0) And (pEditWindow(q)^.Editor^.Filename=Sourcename) Then p:=pEditWindow(q);
		q:=q^.Next;
	Until q=Desktop^.Current;
	If Error>0 Then
	Begin
		If p<>Nil Then
		Begin
			p^.Select;
		End Else
		Begin
			OpenEditor(Sourcename,True);
			p:=pEditWindow(Desktop^.Current);
		End;
		p^.Editor^.SetSelect(ErrorBegin,ErrorEnd,True);
		p^.Editor^.TrackCursor(True);
	End;
End;

Procedure Ass(MakeList : Boolean);
Var
	p : pEditWindow;
	q : pView;
	Dlg : pAssDlg;
	r : tRect;
	Dateiname : String;
Begin
	p:=pEditWindow(Desktop^.Current);
	If Copy(p^.editor^.Filename,Length(p^.editor^.Filename)-3,4)='.ASM' Then
	Begin
		Expand(p^.editor^.Filename);
		p^.Editor^.Save;
		Dlg:=New(pAssDlg,Init);
		Dlg^.Options:=Dlg^.Options or ofCentered;

		Desktop^.Insert(Dlg);
		DateiName:=p^.editor^.Filename;
		Dlg^.Work(Dateiname,MakeList);
		Dlg^.Done;
		EditorApp.MessageView^.SetText(FehlerText[Error]+ErrorText);

		ErrorNr:=1;
		q:=Desktop^.Current;p:=Nil;
		Repeat
			If pEditWindow(q)^.Editor^.Filename[2]=':' Then pEditWindow(q)^.Editor^.LoadFile;
			If (Error>0) And (pEditWindow(q)^.Editor^.Filename=Sourcename) Then p:=pEditWindow(q);
			q:=q^.Next;
		Until q^.Next^.Next=Desktop^.Current;
		If Error>0 Then
		Begin
			If p<>Nil Then
			Begin
				p^.Select;
			End Else
			Begin
				OpenEditor(Sourcename,True);
				p:=pEditWindow(Desktop^.Current);
			End;
			p^.Editor^.SetSelect(ErrorBegin,ErrorEnd,True);
			p^.Editor^.TrackCursor(True);
		End;
	End;
End;


constructor TEditorApp.Init;
var
	H: Word;
	R: TRect;
	i : Byte;
	n : FNameStr;
begin
	MaxHeapSize := HeapSize;
	inherited Init;

	GetExtent(r);
	r.b.x:=r.b.x;
	r.a.x:=r.b.x-39;r.a.y:=r.b.y-1;
	MessageView:=New(pMessageView,Init(r));
	Insert(MessageView);

	EditorApp.MessageView^.SetText(FehlerText[0]);

	GetExtent(r);
	r.b.x:=r.b.x-1;
	r.a.x:=r.b.x-7;r.b.y:=r.a.y+1;
	HeapView:=New(pHeapView,Init(r));
	Insert(HeapView);

	GetExtent(r);
	r.b.x:=r.b.x-9;
	r.a.x:=r.b.x-8;r.b.y:=r.a.y+1;
	ClockView:=New(pClockView,Init(r));
	Insert(ClockView);

	DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
		cmUndo, cmFind, cmReplace, cmSearchAgain]);
	EditorDialog := StdEditorDialog;
	ClipWindow := OpenEditor('', False);
	if ClipWindow <> nil then
	begin
		Clipboard := ClipWindow^.Editor;
		Clipboard^.CanUndo := False;
	end;

	For i:=1 To ParamCount Do
	Begin
		n:=ParamStr(i);
		Expand(n);
		OpenEditor(n,True);
	End;
end;

Procedure   tEditorApp.Idle;
Begin
	tApplication.Idle;
{	MessageView^.Update;}
	HeapView^.Update;
	ClockView^.Update;
End;

procedure TEditorApp.HandleEvent(var Event: TEvent);

procedure FileOpen;
var
	FileName: FNameStr;
begin
	FileName := '*.ASM';
  if ExecuteDialog(New(PFileDialog, Init('*.ASM', 'Datei ffnen',
		'~N~ame', fdOpenButton Or fdAsmButton Or fdLstButton, 100)), @FileName) <> cmCancel then
    OpenEditor(FileName, True);
end;

procedure FileNew;
begin
  OpenEditor('', True);
end;

procedure ChangeDir;
begin
  ExecuteDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure ShowClip;
begin
	ClipWindow^.Select;
	ClipWindow^.Show;
end;

{procedure Calculator;
begin
	InsertWindow(New(PCalculator, Init));
end;}

Procedure NextError;
Begin
	If ErrorNr<ErrorCount-1 Then Inc(ErrorNr) Else ErrorNr:=1;
	ShowError;
End;

Procedure LastError;
Begin
	If ErrorNr>1 Then Dec(ErrorNr) Else ErrorNr:=ErrorCount-1;
	ShowError;
End;

begin
	inherited HandleEvent(Event);
	case Event.What of
		evCommand:
			case Event.Command of
				cmOpen       : FileOpen;
				cmNew        : FileNew;
				cmChangeDir  : ChangeDir;
				cmDosShell   :;
{				cmCalculator : Calculator;}
				cmShowClip   : ShowClip;
				cmAss        : Ass(False);
				cmAssList    : Ass(True);
			else
				Exit;
			end;
	else
		Exit;
	end;
	ClearEvent(Event);
end;

Procedure TEditorApp.InitMenuBar;
Var
  R: tRect;
Begin
  GetExtent(R);
	R.B.Y := R.A.Y + 1;
  MenuBar:=New(PMenuBar,Init(R,NewMenu(
    NewSubMenu('~D~atei'       ,hcNoContext,NewMenu(
      NewItem('~L~aden...'       ,'F3'       ,kbF3      ,cmOpen        ,hcNoContext,
      NewItem('~N~eu'            ,''         ,kbNoKey   ,cmNew         ,hcNoContext,
      NewItem('~S~ichern'        ,'F2'       ,kbF2      ,cmSave        ,hcNoContext,
			NewItem('Sichern ~a~ls...' ,''         ,kbNoKey   ,cmSaveAs      ,hcNoContext,
      NewLine(
			NewItem('~P~fad ndern...' ,''         ,kbNoKey   ,cmChangeDir   ,hcNoContext,
			NewItem('~D~OS-Aufruf'     ,''         ,kbNoKey   ,cmDosShell    ,hcNoContext,
			NewItem('~B~eenden'        ,'Alt-X'    ,kbAltX    ,cmQuit        ,hcNoContext,
		Nil))))))))),
		NewSubMenu('~B~earbeiten'  ,hcNoContext,NewMenu(
			NewItem('~Z~urcknehmen'   ,''         ,kbNoKey   ,cmUndo        ,hcNoContext,
			NewLine(
			NewItem('~A~usschneiden'   ,'Shift-Del',kbShiftDel,cmCut         ,hcNoContext,
			NewItem('~K~opieren'       ,'Ctrl-Ins' ,kbCtrlIns ,cmCopy        ,hcNoContext,
			NewItem('~E~inkleben'      ,'Shift-Ins',kbShiftIns,cmPaste       ,hcNoContext,
			NewItem('Zeige A~b~lage'   ,''         ,kbNoKey   ,cmShowClip    ,hcNoContext,
			NewLine(
			NewItem('~L~schen'        ,'Ctrl-Del' ,kbCtrlDel ,cmClear       ,hcNoContext,
		Nil))))))))),
		NewSubMenu('~S~uchen'      ,hcNoContext,NewMenu(
			NewItem('~F~inde...'       ,''         ,kbNoKey   ,cmFind        ,hcNoContext,
			NewItem('~E~rsetzen...'    ,''         ,kbNoKey   ,cmReplace     ,hcNoContext,
			NewItem('~W~iederhohlen'   ,''         ,kbNoKey   ,cmSearchAgain ,hcNoContext,
		Nil)))),
		NewSubMenu('~F~enster'     ,hcNoContext,NewMenu(
			NewItem('~G~re/bewegen'  ,'Ctrl-F5'  ,kbCtrlF5  ,cmResize      ,hcNoContext,
			NewItem('~Z~oom'           ,'F5'       ,kbF5      ,cmZoom        ,hcNoContext,
			NewItem('N~e~beneinander'  ,''         ,kbNoKey   ,cmTile        ,hcNoContext,
			NewItem('~~bereinander'   ,''         ,kbNoKey   ,cmCascade     ,hcNoContext,
			NewItem('~N~chstes'       ,'F6'       ,kbF6      ,cmNext        ,hcNoContext,
			NewItem('~L~etztes'        ,'Shift-F6' ,kbShiftF6 ,cmPrev        ,hcNoContext,
			NewItem('~S~chliessen'     ,'Alt-F3'   ,kbAltF3   ,cmClose       ,hcNoContext,
		Nil)))))))),
		NewSubMenu('~A~ssemblieren',hcNoContext,NewMenu(
			NewItem('~A~ssemblieren '             ,'F9'        ,kbF9      ,cmAss         ,hcNoContext,
			NewItem('~A~ssemblieren mit Listfile' ,'CTRL-F9'   ,kbCtrlF9  ,cmAssList     ,hcNoContext,
		Nil))),
	Nil))))))));
End;

Procedure tEditorApp.InitStatusLine;
Var
  R: tRect;
Begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
	New(StatusLine,Init(R,
		NewStatusDef(0,$FFFF,
	    NewStatusKey('~F2~ Sichern'       , kbF2     , cmSave,
  	  NewStatusKey('~F3~ Laden'         , kbF3     , cmOpen,
	    NewStatusKey('~Alt-F3~ Schliessen', kbAltF3  , cmClose,
			NewStatusKey(''                   , kbCtrlF5 , cmResize,
		Nil)))),
  Nil)));
End;

Procedure tEditorApp.OutOfMemory;
Begin
  MessageBox('Nicht genug Speicher fr diese Operation.',nil,mfError+mfOkButton);
End;

begin
  EditorApp.Init;
  EditorApp.Run;
  EditorApp.Done;
end.
